//Legal Notice: (C)2008 Altera Corporation. All rights reserved.  Your
//use of Altera Corporation's design tools, logic functions and other
//software and tools, and its AMPP partner logic functions, and any
//output files any of the foregoing (including device programming or
//simulation files), and any associated documentation or information are
//expressly subject to the terms and conditions of the Altera Program
//License Subscription Agreement or other applicable license agreement,
//including, without limitation, that your use is for the sole purpose
//of programming logic devices manufactured by Altera and sold by Altera
//or its authorized distributors.  Please refer to the applicable
//agreement for further details.

// synthesis translate_off
`timescale 1ns / 1ps
// synthesis translate_on

// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module user_blk (
               // inputs:
                address,
                chipselect,
                clk,
                in_port,
                reset_n,
                write_n,
                writedata,

               // outputs:
                irq,
                readdata
             )
;

  output           irq;
  output  [  7: 0] readdata;
  input   [  5: 0] address;
  input            chipselect;
  input            clk;
  input   [  3: 0] in_port;
  input            reset_n;
  input            write_n;
  input   [  7: 0] writedata;

  wire             clk_en;
  reg     [  3: 0] d1_data_in;
  reg     [  3: 0] d2_data_in;
  reg     [  7: 0] cmd;
  wire    [  3: 0] data_in;
  reg     [  3: 0] edge_capture;
  wire             edge_capture_wr_strobe;
  wire    [  3: 0] edge_detect;
  wire             irq;
  reg     [  3: 0] irq_mask;
  wire    [  7: 0] read_mux_out;
  reg     [  7: 0] readdata;
  reg     [  7: 0] data_1;


  wire                                   start_in;
  wire                                   lap_in;
  wire                                   stop_in;
  wire                                   clear_in;
  reg    [2:0]                           start_dff;
  reg    [2:0]                           lap_dff;
  reg    [2:0]                           stop_dff;
  reg    [2:0]                           clear_dff;
  reg                                    start_sig;
  reg                                    lap_sig;
  reg                                    stop_sig;
  reg                                    clear_sig;
  reg                                    CNT_EN;
  wire                                   init_sig; 
  reg   [18:0]                           count_base;
  wire   [3:0]                           count_10u;
  wire   [3:0]                           count_100u;
  wire   [3:0]                           count_1m;
  wire   [3:0]                           count_10m;
  wire   [3:0]                           count_100m;
  wire   [3:0]                           count_1s;
  wire   [3:0]                           count_10s;
  wire                                   count_10u_carry;
  wire                                   count_100u_carry;
  wire                                   count_1m_carry;
  wire                                   count_10m_carry;
  wire                                   count_100m_carry;
  wire                                   count_1s_carry;
  wire                                   count_10s_carry;
  reg   [3:0]                            rd_count_10u;
  reg   [3:0]                            rd_count_100u;
  reg   [3:0]                            rd_count_1m;
  reg   [3:0]                            rd_count_10m;
  reg   [3:0]                            rd_count_100m;
  reg   [3:0]                            rd_count_1s;
  reg   [3:0]                            rd_count_10s;
   
  assign clk_en = 1;
  //s1, which is an e_avalon_slave
  /*
  assign read_mux_out = ({4 {(address == 0)}} & data_in) |
    ({4 {(address == 2)}} & irq_mask) |
    ({4 {(address == 3)}} & edge_capture);
  */
  assign read_mux_out = (address == 0)?{4'b0000,data_in}:
                        (address == 8)?{4'b0000,irq_mask}: 
                        (address == 12)?{4'b0000,edge_capture}:
                        (address == 16)?{cmd}:
                        (address == 32)?{4'h0, rd_count_10u}:
                        (address == 36)?{4'h0, rd_count_100u}:
                        (address == 40)?{4'h0, rd_count_1m}:
                        (address == 44)?{4'h0, rd_count_10m}:
                        (address == 48)?{4'h0, rd_count_100m}:
                        (address == 52)?{4'h0, rd_count_1s}:
                        (address == 56)?{4'h0, rd_count_10s}:8'h00;
 
   
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          readdata <= 0;
      else if (clk_en)
          readdata <=read_mux_out;
    end


  assign data_in = in_port;
 
   
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          irq_mask <= 0;
      else if (chipselect && ~write_n && (address == 8))
          irq_mask <= writedata[3 : 0];
    end


  assign irq = |(edge_capture & irq_mask);
  assign edge_capture_wr_strobe = chipselect && ~write_n && (address == 12);
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          edge_capture[0] <= 0;
      else if (clk_en)
          if (edge_capture_wr_strobe)
              edge_capture[0] <= 0;
          else if (edge_detect[0])
              edge_capture[0] <= -1;
    end


  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          edge_capture[1] <= 0;
      else if (clk_en)
          if (edge_capture_wr_strobe)
              edge_capture[1] <= 0;
          else if (edge_detect[1])
              edge_capture[1] <= -1;
    end


  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          edge_capture[2] <= 0;
      else if (clk_en)
          if (edge_capture_wr_strobe)
              edge_capture[2] <= 0;
          else if (edge_detect[2])
              edge_capture[2] <= -1;
    end


  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          edge_capture[3] <= 0;
      else if (clk_en)
          if (edge_capture_wr_strobe)
              edge_capture[3] <= 0;
          else if (edge_detect[3])
              edge_capture[3] <= -1;
    end


  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
        begin
          d1_data_in <= 15;
          d2_data_in <= 15;
        end
      else if (clk_en)
        begin
          d1_data_in <= data_in;
          d2_data_in <= d1_data_in;
        end
    end


  assign edge_detect = d1_data_in ^  d2_data_in;


  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          cmd <= 255;
      else if (chipselect && ~write_n && (address == 16))
          cmd <= writedata[7 : 0];
    end

 
 //
 // input sig 
 //
   assign start_in = ((d2_data_in[0]==1'b0)||(cmd[0]==1'b0))?1'b0:1'b1;
   assign lap_in = ((d2_data_in[1]==1'b0)||(cmd[1]==1'b0))?1'b0:1'b1;
   assign stop_in = ((d2_data_in[2]==1'b0)||(cmd[2]==1'b0))?1'b0:1'b1;
   assign clear_in = ((d2_data_in[3]==1'b0)||(cmd[3]==1'b0))?1'b0:1'b1;
 
  //always @( posedge Bus2IP_Clk or posedge Bus2IP_Reset )
  //  if ( Bus2IP_Reset == 1 )
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
      begin
        start_dff <= 3'b111;
        lap_dff <= 3'b111;
        stop_dff <= 3'b111;
        clear_dff <= 3'b111;
        start_sig <= 1'b0;
        lap_sig <= 1'b0;
        stop_sig <= 1'b0;
        clear_sig <= 1'b0;
      end
    else
      begin
        //start 
        start_dff <= {start_dff[1:0],start_in};
        if (start_dff[2:1]==2'b10)
          start_sig <= 1'b1;
        else
          start_sig <= 1'b0;
        //lap
        lap_dff <= {lap_dff[1:0],lap_in};
        if (lap_dff[2:1]==2'b10)
          lap_sig <= 1'b1;
        else
          lap_sig <= 1'b0;
        stop_dff <= {stop_dff[1:0],stop_in};
        //stop 
        if (stop_dff[2:1]==2'b10)
          stop_sig <= 1'b1;
        else
          stop_sig <= 1'b0;
        //clear
        clear_dff <= {clear_dff[1:0],clear_in};
        if (clear_dff[2:1]==2'b10)
          clear_sig <= 1'b1;
        else
          clear_sig <= 1'b0;
      end // else: !if(reset_n == 0)
    end
       
 //
 //counter_en
 //     
  //always @( posedge Bus2IP_Clk or posedge Bus2IP_Reset )
  //  begin
  //    if ( Bus2IP_Reset == 1 )
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
        CNT_EN <= 1'b0;    
      else
        if (start_sig == 1'b1)
          CNT_EN <= 1'b1;
        else
          if (stop_sig == 1'b1)    
            CNT_EN <= 1'b0;
          else     
            CNT_EN <= CNT_EN;
    end // always @ ( posedge Bus2IP_Clk or posedge Bus2IP_Reset )
 //
 //counter
 //     
 
  //always @( posedge Bus2IP_Clk or posedge Bus2IP_Reset )
  //  begin
  //    if ( Bus2IP_Reset == 1 )
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
        count_base <= 19'd0;
      else
        if (init_sig == 1'b1)
          count_base <= 19'd0;
        else
          if (CNT_EN== 1'b1)
            //if (count_base == 19'd49999)  // 1ms
            //if (count_base == 19'd499)  // 1us clk=50MHz
            if (count_base == 19'd199)  // 1us clk=20MHz
            //if (count_base == 19'd9)
              count_base <= 19'd0;
            else
              count_base <= count_base +19'd1;
    end // always @ (posedge clk or negedge reset_n)
   
assign init_sig = ((start_sig==1'b1)||(clear_sig==1'b1))?1'b1:1'b0;
   
//assign base_en = ((count_base == 19'd49999)&&(CNT_EN== 1'b1))?1'b1:1'b0; //1ms
//assign base_en = ((count_base == 19'd499)&&(CNT_EN== 1'b1))?1'b1:1'b0; //10us clk=50MHz
assign base_en = ((count_base == 19'd199)&&(CNT_EN== 1'b1))?1'b1:1'b0; //10us clk=20MHz
//assign base_en = ((count_base == 19'd9)&&(CNT_EN== 1'b1))?1'b1:1'b0;

count_10 c_10u(
 .CLK    ( clk ),   
 .RESET_N  ( reset_n),
 .EN     ( base_en),
 .INIT   ( init_sig),
 .COUNT  ( count_10u),
 .CARRY  ( count_10u_carry)
);
   
count_10 c_100u(
 .CLK    ( clk ),   
 .RESET_N  ( reset_n),
 .EN     ( count_10u_carry),
 .INIT   ( init_sig),
 .COUNT  ( count_100u),
 .CARRY  ( count_100u_carry)
);
   
count_10 c_1m(
 .CLK    ( clk ),   
 .RESET_N  ( reset_n),
 .EN     ( count_100u_carry),
 .INIT   ( init_sig),
 .COUNT  ( count_1m),
 .CARRY  ( count_1m_carry)
);
   
count_10 c_10m(
 .CLK    ( clk ),   
 .RESET_N  ( reset_n),
 .EN     ( count_1m_carry),
 .INIT   ( init_sig),
 .COUNT  ( count_10m),
 .CARRY  ( count_10m_carry)
);

count_10 c_100m(
 .CLK    ( clk ),   
 .RESET_N  ( reset_n),
 .EN     ( count_10m_carry),
 .INIT   ( init_sig),
 .COUNT  ( count_100m),
 .CARRY  ( count_100m_carry)
);

count_10 c_1s(
 .CLK    ( clk ),   
 .RESET_N  ( reset_n),
 .EN     ( count_100m_carry),
 .INIT   ( init_sig),
 .COUNT  ( count_1s),
 .CARRY  ( count_1s_carry)
);

count_10 c_10s(
 .CLK    ( clk ),   
 .RESET_N  ( reset_n),
 .EN     ( count_1s_carry),
 .INIT   ( init_sig),
 .COUNT  ( count_10s),
 .CARRY  ( count_10s_carry)
);
   
// read data
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
        begin
           rd_count_10u  <= 4'h0;
           rd_count_100u <= 4'h0;
           rd_count_1m   <= 4'h0;
           rd_count_10m  <= 4'h0;
           rd_count_100m <= 4'h0;
           rd_count_1s   <= 4'h0;
           rd_count_10s  <= 4'h0;
        end
      else
        if ((stop_sig==1'b1)||(lap_sig==1'b1))
        begin
           rd_count_10u   <= count_10u ;
           rd_count_100u   <= count_100u ;
           rd_count_1m   <= count_1m ;
           rd_count_10m   <= count_10m ;
           rd_count_100m   <= count_100m ;
           rd_count_1s   <= count_1s ;
           rd_count_10s   <= count_10s ;
        end // else: !if(reset_n == 0)
    end
   
endmodule

